/**
 *-----------------------------------------------------------------------------*
 * License: Concrete5 marketplace :                                            *
 * http://www.concrete5.org/help/legal/commercial_add-on_license/              *
 *                                                                             *
 * @author (Florian Delizy)                                                    *
 *                                                                             *
 * Copyright(C) 2015 Florian Delizy <florian.delizy@gmail.com>                 *
 *-----------------------------------------------------------------------------*
 */

// Called from the code (grid management)

function getRowsFromCSV()
{
    var txt = $('#tags').val().trim();
    if ('' == txt) {
        return [];
    }
    var lines = txt.split('\n');
    data = [];
    for (var i = 0; i < lines.length; i++)
    {
        var d = {};
        var els = lines[i].split(",");
        for (var j = 0; j < els.length ; j++) {
            var elt = String(els[j]).trim().replace(/^'(.*)'$/, '$1').replace(/\\'/, "'");
            if (elt == '') continue;
            if (elt == "''") continue;
            var key = [jqGridOptions.colModel[j].index];
            var val = elt.replace(/\\'/g, "'");
            d[key] = val;
        }
        data.push(d);
    }
    console.debug("Will return CSV data:", data);
    return data;
}

function initGrid() 
{
    var data = getRowsFromCSV();
    data.push({});

    var wrapper = $('#cloudify-tags-advanced');

    var lastSelected;

    wrapper.jqGrid({
        datatype: 'clientSide',
        height: 134,
        width: 680,
        data: data,
        colNames: jqGridOptions.colNames,
        colModel: jqGridOptions.colModel,
        multiselect: false,
        viewrecords: true,
        caption: jqGridOptions.caption,
        altRows: true,
        cmTemplate: {
            resize: true,
            editable: true,
            align: 'center',
        },
        scroll: true,
        cellSubmit: 'clientArray',
        url: 'clientArray',
        editurl: 'clientArray',
        onSelectRow: function(id) {
            if (id && id != lastSelected) {
                wrapper.jqGrid('saveRow', lastSelected, false, 'clientArray');
                wrapper.jqGrid('editRow', id, true);
                lastSelected = id;
            }
        }
    });

    jqGridColor.init(wrapper);

    
    wrapper.jqGrid('navGrid','#cloudify-tags-advanced-footer',{edit:true,add:true,del:true});
    wrapper.jqGrid('bindKeys', {"onEnter":function( rowid ) { alert("You enter a row with id:"+rowid)} } );

    $('#cloudify-manual-words div.ui-widget.ui-jqgrid').resizable();
    $('#cloudify-manual-words div.ui-widget.ui-jqgrid').resize(function(e,jq) {
        var container = $(e.target);
        var width = container.innerWidth();
        var height = container.innerHeight();
        wrapper.jqGrid('setGridWidth', width).jqGrid('setGridHeight', height);
    });
}

function initTagGrid()
{
    if (parseInt($("#wordsSource").val()) == SOURCE_MANUAL_ADVANCED) initGrid();
}


// must be called from the form to init as auto.js is not loaded at each form show but only the first show
// -- this is a big change from 5.6 boys :(

function gnt_cloudify_init_form()
{

    // Form Logic :
    $('#wordsSource').change(function()
    {
        var val = parseInt($("#wordsSource").val());
        var type = parseInt($("#searchType").val());

        if ($.inArray(val, MANUAL_WORDSOURCES) == -1) {
            $("#cloudify-pagesearch-options").show();
            $("#cloudify-manual-words").hide();

            if ($.inArray(type, NO_PAGE_TYPES) != -1) {
                $("#cloudify-page-types-filter").hide();
            }
            else $("#cloudify-page-types-filter").show();
        } else {
            $("#cloudify-pagesearch-options").hide();
            $("#cloudify-manual-words").show();
            if (val == SOURCE_MANUAL)
            {
                $("#cloudify-manual-word-list").show();
                $("#cloudify-advanced-tag-list").hide();
            } else {
                $("#cloudify-manual-word-list").hide();
                $("#cloudify-advanced-tag-list").show();
                initGrid();
            }

        }

    });

    $('#searchType').change(function()
    {
        var type = parseInt($("#searchType").val());
        if ($.inArray( type, NO_PAGE_TYPES)  != -1) {
            $("#cloudify-page-types-filter").hide();
        } else {
            $("#cloudify-page-types-filter").show();
        }
    });


    $('#caseInsensitive').change( function()
    {
        if ($('#caseInsensitive').is(":checked")) {
            $("#word-cloudify-uppercase").show();
        } else {
            $("#word-cloudify-uppercase").hide();
        }
    });


    $('#searchType').change(function()
    {
        var v = parseInt($("#searchType").val());

        if ($.inArray(v, SEARCH_UNDER_LIST ) != -1) {
            $("#cloudify-page-selector").show();
        } else {
            $("#cloudify-page-selector").hide();
        }
    });

    // color preview

    function updateColorPreview()
    {
        var first = tinycolor($("#ccm-colorpicker-gradientStart").val());
        var last  = tinycolor($("#ccm-colorpicker-gradientEnd").val());

        var i;

        for (i = 0; i < 20; i++)
        {
            var r = first.toRgb().r * ((20 - i) / 20) + last.toRgb().r  * (i / 20);
            var g = first.toRgb().g * ((20 - i) / 20) + last.toRgb().g  * (i / 20);
            var b = first.toRgb().b * ((20 - i) / 20) + last.toRgb().b  * (i / 20);

            var color = tinycolor({r: r, g: g, b: b});
            var el = $('#color-preview-' + COLORING_GRADIENT + '-' + i);

            if (el) {
                el.css('background-color', "#" + color.toHex());
            }
        }

        $('.word-cloudify-color-preview').hide();
        var color = $('#coloringType').val();

        var e = $('#word-cloudify-colors-' + color);
        if (e) {
            e.show();
        }
    }

    $('#coloringType').change(function()
    {
        updateColorPreview();

        var type = $('#coloringType').val();
        if ($.inArray( type, USE_COLOR_LIST ) != -1) {
            $("#word-cloudify-colors").show();
            if ($.inArray(type, USE_SECOND_COLOR_LIST) != -1) {
                $(".word-cloudify-second-color").show();
            } else {
                $(".word-cloudify-second-color").hide();
            }
        } else {
            $("#word-cloudify-colors").hide();
        }

    });

    $("#ccm-colorpicker-gradientStart").change(updateColorPreview);
    $("#ccm-colorpicker-gradientEnd").change(updateColorPreview);

    // Tabs and panes

    $('#cloudify-tab-menu a').click(function(e)
    {
        e.preventDefault();

        $('#cloudify-tab-menu li').removeClass('active');
        $(this.parentNode).addClass('active');
        pane = $(this).attr('href').replace('#','');
        $('#cloudify-tabs div.tab-pane').removeClass('active');
        $('#cloudify-tabs div.tab-pane#' + pane ).addClass('active');
    });

    function gridToCSV(data)
    {
        var str = '';
        for (var i = 0; i < data.length ; i++) {
            var line = data[i];
            var t = '';
            var comma = '';

            var word = line[jqGridOptions.colModel[0].name];
            if ('undefined' == typeof(word) || '' == word) {
                continue;
            }

            for (var j = 0; j < jqGridOptions.colModel.length ; j++) {
                var key = jqGridOptions.colModel[j].name;
                var val = 'undefined' == typeof(line[key]) ? '' : String(line[key]);
                t += comma + "'" + val.replace( /'/g, '\\\'')  + "'";
                comma = ",";
            }
            str += t + "\n";
        }
        return str;
    }


    $('#loadD3js').change(function()
    {
        if ($(this).is(':checked')) {
            $("#cloudify-advanced-useLocalD3Js").show();
        } else {
            $("#cloudify-advanced-useLocalD3Js").hide();
        }
    });

    $('#precalc').change(function()
    {
        if ($(this).is(':checked')) {
            $("#cloudify-advanced-cacheCalc").show();
        } else {
            $("#cloudify-advanced-cacheCalc").hide();
        }
    });

    $('#loadEffect').change( function()
    {
        if ($(this).is(':checked'))
        {
            $("#cloudify-advanced-loadD3js").show();
            if ($("#loadD3js").is(':checked')) {
                $("#cloudify-advanced-useLocalD3Js").show();
            } else {
                $("#cloudify-advanced-useLocalD3Js").hide();
            }
        } else {
            $("#cloudify-advanced-loadD3js").hide();
            $("#cloudify-advanced-useLocalD3Js").hide();
        }
    });

    $("#advanced input[type=checkbox]").change( function ()
    {
        if ($(this).is(':checked')) {

            $(".onchecked", this.parentNode).show();
            $(".unchecked", this.parentNode).hide();
        } else {
            $(".onchecked", this.parentNode).hide();
            $(".unchecked", this.parentNode).show();
        }
    });


    $('#redirect').change( function()
    {
        var $this = $(this);
        if ($this.is(':checked')) {
            $('#behavior-redirect').show();
        } else {
            $('#behavior-redirect').hide();
        }
    });

    $('#redirectType').change( function()
    {
        var val = parseInt($(this).val());
        if (val == REDIRECT_TO_PAGE)
        {
            $("#behavior-redirect-link").hide();
            $("#behavior-redirect-page").show();
        } else {
            $("#behavior-redirect-link").show();
            $("#behavior-redirect-page").hide();
        }

    });


    function checkAddCustomVar()
    {
        var targetType = parseInt($("#targetType").val());
        var customVar = $('#addCustomVar').is(':checked');

        var customDiv = $("#behavior-custom-var");

        customDiv.hide();
        $('#add-custom-variable').hide();

        if (targetType != TARGET_SEARCH_CUSTOM && targetType != TARGET_SEARCH_NOSEARCH) {
            $('#add-custom-variable').show();
        }

        if (targetType == TARGET_SEARCH_CUSTOM || customVar) {
            customDiv.show();
        }
    }


    $("#targetType").change(checkAddCustomVar);
    $('#addCustomVar').change(checkAddCustomVar);

//    Note for self (when the core gets fixed):
//    This is the "supposed" best way to do, but the problem is the event gets fired *after* the form is submitted...
//    so we can't rely on it :( at least not as of 5.7.3.1
//
//    // to debug use: ConcreteEvent.debug(true)
//    ConcreteEvent.subscribe('EditModeUpdateBlockComplete', function(e) {
//        if (parseInt($("#wordsSource").val()) == SOURCE_MANUAL_ADVANCED) {
//            var data = $('#cloudify-tags-advanced').jqGrid('getRowData');
//            $("#tags").val(gridToCSV(data));
//        }
//    });
//
//  instead, we are stuck with the working (hacky) way:
    $('#ccm-form-submit-button').click(function() {
        if (parseInt($("#wordsSource").val()) == SOURCE_MANUAL_ADVANCED) {
            var data = $('#cloudify-tags-advanced').jqGrid('getRowData');
            $("#tags").val(gridToCSV(data));
        }
    });


    updateColorPreview();
}

// vim: set ts=4 expandtab cindent smarttab :
