/**
 *-----------------------------------------------------------------------------*
 * jqGrid spectrum integration                                                 *
 * License: Concrete5 marketplace :                                            *
 * http://www.concrete5.org/help/legal/commercial_add-on_license/              *
 *                                                                             *
 * @author (Florian Delizy)                                                    *
 *                                                                             *
 * Copyright(C) 2015 Florian Delizy <florian.delizy@gmail.com>                 *
 *-----------------------------------------------------------------------------*
 */

var jqGridColor = {
    _spectrums: [],
    editor: function (value, options) {
        var element = $('<div class="jqGrid-color-editor"><input class="jqGrid-color-input"></input><input type="color" class="jqGrid-spectrum-holder"></input></div>');

        element.attr('data-id', options.id);
        element.attr('data-rowId', options.rowId);

        var inputS = element.find('input.jqGrid-spectrum-holder');
        var input =  element.find('input.jqGrid-color-input');

        input.val(value);
        input.attr('type', 'text');
        input.addClass('editable');

        inputS.val(value);
        inputS.addClass("spectrum-editor");

        input.change(function(){
            $(this).next('input').spectrum('set', $(this).val());
        });

        function updateColor(color)
        {
            var container = $(this);
            var inputs = element.find('input');

            if (!color) {
                inputs.val('');
                return;
            }

            var hexColor = color.toHexString();
            inputs.val(hexColor);
        }

        inputS.spectrum({
                showInput: false 
                ,color: value
                ,showInitial: true 
                ,showButtons: false
                ,preferredFormat: 'hex'
                ,allowEmpty: true
                ,showSelectionPalette: true
                ,className: 'ccm-widget-colorpicker'
                ,cancelText: ccm_t('cancel')
                ,chooseText: ccm_t('choose')
                ,clearText:  ccm_t('clear')
                ,change: updateColor.bind(element)
                ,move: updateColor.bind(element)
                // TODO (later): allow alpha with showAlpha (need to change all colors to int rgb, since hex is not supported)
        });

        jqGridColor._spectrums.push(inputS.spectrum('container'));

        return element;

    },

    controller: function jqColorController(elem, op, value) {
        var input = $(elem).find('input.jqGrid-color-input');
        if ('get' == op) {
            return input.val();
        } else if ('set' == op) {
            input.val(value);
        }
    },

    editoptions: function(opts) {
        var options = {
            custom_element: jqGridColor.editor,
            custom_value: jqGridColor.controller
        };
        if (opts) {
            options = $.extend(options, opts);
        }
        return options;
    },

    closeAll: function() {
        for (var i = 0; i < jqGridColor._spectrums.length; i++) {
            jqGridColor._spectrums[i].hide();
        }
    },

    // ensure all spectrums are closed when a editline is saved
    init: function(wrapper) {
        wrapper.bind('jqGridInlineAfterSaveRow', function(evt) {
            jqGridColor.closeAll();
        });
    }
}

$(function(){
    $.extend($.fn.fmatter, {
        'color': function (value, options, rowObject) {
            if ('' == value || typeof(value) == 'undefined') {
                value = '';
            }

            var str = '<div class="jqGrid-color-result" ';
            if (value) {
                var r = (255 - parseInt(value.substr(1,2), 16)).toString(16,2);
                var g = (255 - parseInt(value.substr(3,2), 16)).toString(16,2);
                var b = (255 - parseInt(value.substr(5,2), 16)).toString(16,2);
                var txtColor = "#" + (r.length==1?"0"+r:r) + (g.length==1?"0"+g:g) + (b.length==1?"0"+b:b);

                str += 'style="background-color: ' + value + ';color: ' + txtColor + '" ';
            }
            str += ">" + value + "</div>";
            return str;
        }
    });

    $.extend($.fn.fmatter.color, {
        unformat: function (value, options, cell) {
            var val = $(cell).find('div.jqGrid-color-result').text().trim();
            if ('&nbsp' == val || !val) {
                return '';
            }
            return val;
        }
    });

});
